const luhnCheck =( num, radix) => {
    if(radix == null) { 
        radix = 10
    }
    const arr = `${num}`
      .split('')
      .reverse()
      .map(x => Number.parseInt(x, radix));
    const lastDigit = arr.shift();
    let sum = arr.reduce(
      (acc, val, i) =>
        i % 2 !== 0 ? acc + val : acc + ((val *= 2) > 9 ? val - 9 : val),
      0
    );
    sum += lastDigit;
    return sum % 10 === 0;
  };

  function clearStatus() {
    resultElement.innerText = '';
  }


  function showStatus(msg, isError) { 
    if(isError === null) { 
        isError = false;
    }
    resultElement.innerText = msg;
    if(isError) {
        resultElement.className = 'error';
    } else {
        resultElement.className = 'nonerror';
    }
  }

  function testValue() {
    let result = luhnCheck(numberToCheckElement.value);
    if(result) {
        showStatus('pass', false);
        console.log("the number passes the check");
    } else {
        showStatus('fail', true);
        console.log("The number does not pass")
    }
    console.log('test Value time')
  }

  var inputTimeout = null;
  function inputChanged() { 
    clearStatus();
    if(inputTimeout) {
      clearTimeout(inputTimeout);
    }
    inputTimeout = setTimeout(testValue, 1333);
  }


var nuberToCheckElement;
var resultElement;

  function pageLoaded() {
    numberToCheckElement = document.getElementById('numberToCheck');
    numberToCheckElement.addEventListener('keydown', inputChanged);
    resultElement = document.getElementById('result');
  }
  
  console.log(luhnCheck('4485275742308327')); // true
  console.log(luhnCheck(6011329933655299)); //  true
  console.log(luhnCheck(123456789)); // false
  console.log(luhnCheck("0701040004000000000000010907", 0x10));